require "util"
require "defines"

function _init()
	remote.call("EvoGUI", "create_remote_sensor", { mod_name = "steinios_wind_sensor",
													name = "steinio_ws", 
													text = "Wind speed: 0/m, Direction: N", 
													caption = "Wind speed" 
												}
	)
end

--Register a callback to be run on module init.
script.on_init( 
	function()
		_init()
	end
)

--Register a function to be run on module load.
script.on_load(
	function()
		_init()
	end
)

--It is fired once every tick. Since this event is fired every tick, its handler shouldn't include performance heavy code.
script.on_event(defines.events.on_tick, 
	function() 		
		if game.tick % 60 ~= 0 then return end
			
		remote.call(
			"EvoGUI", 
			"update_remote_sensor", 
			"steinio_ws", 
			"Wind speed: " .. wind_speed(game.wind_speed) .. "/m, Direction: " .. wind_orientation(game.wind_orientation)
		)
		
	end
)

function wind_speed(speed)
	return tostring(speed * 100) 
end

function wind_orientation(orientation)
	orientation = orientation or 0
	
	if orientation >= 0 		and orientation <= 0.031254 then return "N" 	end
	if orientation >= 0.031255 	and orientation <= 0.093754 then return "NNE" 	end
	if orientation >= 0.093755 	and orientation <= 0.156254 then return "NE" 	end
	if orientation >= 0.156255 	and orientation <= 0.218754 then return "ENE" 	end
	if orientation >= 0.218755 	and orientation <= 0.281254 then return "E" 	end
	if orientation >= 0.281255 	and orientation <= 0.343754 then return "ESE"	end
	if orientation >= 0.343755 	and orientation <= 0.406254 then return "SE" 	end
	if orientation >= 0.406255 	and orientation <= 0.468754 then return "SSE" 	end
	if orientation >= 0.468755 	and orientation <= 0.531254 then return "S" 	end
	if orientation >= 0.531255 	and orientation <= 0.593754 then return "SSW" 	end
	if orientation >= 0.593755 	and orientation <= 0.656254 then return "SW" 	end
	if orientation >= 0.656255 	and orientation <= 0.718754 then return "WSW" 	end
	if orientation >= 0.718755 	and orientation <= 0.781254 then return "W" 	end
	if orientation >= 0.781255 	and orientation <= 0.843754 then return "WNW"	end
	if orientation >= 0.843755 	and orientation <= 0.906254 then return "NW" 	end
	if orientation >= 0.906255 	and orientation <= 0.968754 then return "NNW" 	end
	if orientation >= 0.968755 	and orientation <= 1 		then return "N" 	end
	

	return tostring(orientation)
end

function roundToNthDecimal(num, n)
	local mult = 10^(n or 0)
	return math.floor(num * mult + 0.5) / mult
end